#define STRICT				//   
#include <windows.h>		//   windows
#include <windowsx.h>		//  windows
#include <commctrl.h>		//     windows

#include "HeaderEx.h"



LRESULT CALLBACK HeaderExWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
void HeaderEx_Title(HWND hwnd);


/*
	   ListView'  
 */
BOOL InitListViewEx(HWND hWndLV)
{
	BOOL ret = FALSE;
	char out[200];

//    ,    
//    
	GetClassName(hWndLV,out,sizeof(out));
	if(!lstrcmpi(out,WC_LISTVIEW))
	{
	//       
		ret = InitHeaderEx(ListView_GetHeader(hWndLV));
	}
	return ret;
}

/*
	   SysHeader32  
 */
BOOL InitHeaderEx(HWND hWndHdr)
{
	BOOL ret = FALSE;
	char out[200];

//    ,    
//    
	GetClassName(hWndHdr,out,sizeof(out));
	if(!lstrcmpi(out,WC_HEADER))
	{
	//  WndProc   
	// :        
	//           -?
	// :         , 
	//          ,     ,  
	//         -  .      ?  
	//           ,   GWL_USERDATA?     
	//               .
		ret = (BOOL)SetWindowLong(hWndHdr,GWL_WNDPROC,(LONG)HeaderExWndProc);
	}
	return ret;
}


/*
      -    
	    -    256,
	 "" 
 */
DWORD OffsetColor(DWORD color,BYTE offset,BOOL dir)
{
	DWORD ncolor = color;
	if(!dir)
	{
		if(GetRValue(ncolor)>offset) ncolor-=offset;				else ncolor&=0xffffff00;
		if(GetGValue(ncolor)>offset) ncolor-=(DWORD)(offset<<8);	else ncolor&=0xffff00ff;
		if(GetBValue(ncolor)>offset) ncolor-=(DWORD)(offset<<16);	else ncolor&=0xff00ffff;
	}
	else
	{
		if((GetRValue(ncolor)+offset)<0x100) ncolor+=offset;				else ncolor|=0x000000ff;
		if((GetGValue(ncolor)+offset)<0x100) ncolor+=(DWORD)(offset<<8);	else ncolor|=0x0000ff00;
		if((GetBValue(ncolor)+offset)<0x100) ncolor+=(DWORD)(offset<<16);	else ncolor|=0x00ff0000;
	}
	return ncolor;
}


/*
	    
*/
typedef struct HEADEREXSHOWDATA
{
	HEADEREXSHOWDATA*	next;
	int		width;
	char	szName[500];
} *LPHEADEREXSHOWDATA;

/*
	   
	       
	    "W" -   MSDN
	    ,   
	 
*/
int HeaderExTitleHeight(HWND hwnd)
{
	int titleheight = 0;
	char out[500];
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	hdi.pszText = out;
	hdi.cchTextMax = sizeof(out);

	SIZE sz;
	HDC dc = GetDC(hwnd);
	HFONT hfnt = GetWindowFont(GetParent(hwnd));
	HFONT ofnt = SelectFont(dc,hfnt);
	GetTextExtentPoint32(dc,"W",1,&sz);
	SelectFont(dc,ofnt);
	ReleaseDC(hwnd, dc);

	int cnt = Header_GetItemCount(hwnd);
	for(int i=0;i<cnt;i++)
	{
		Header_GetItem(hwnd, i, &hdi);
		int tmp=0; char *a=out;
		while(a) { tmp++; a=strchr(a+1,'\n'); }
		if(titleheight<tmp) titleheight=tmp;
	}
	sz.cy+=2;//*GetSystemMetrics(SM_CXDLGFRAME)+2;
	titleheight*=sz.cy;
	return titleheight;
}


/*
	   ,    
	 
 */
LRESULT CALLBACK HeaderExWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	//       
	//  .    ,     
	//  ,      ...
	//     .
		case HDM_LAYOUT:
		{
			HDLAYOUT* lphl = (HDLAYOUT*)lParam;
			CallWindowProc((WNDPROC)GetClassLong(hwnd,GCL_WNDPROC), hwnd, msg, wParam, lParam);
			if(lphl->pwpos && lphl->pwpos->cy)
			{
				lphl->prc->top = HeaderExTitleHeight(hwnd)+5;
				lphl->pwpos->cy = HeaderExTitleHeight(hwnd)+4;
			}
		}
		return TRUE;
	//     , ,  
	//  ,    ,     
	//   .
	//    ,         
	//   BeginPaint-EndPaint,  -   - ...
	//      ...
		case WM_PAINT:
			SendMessage(hwnd, WM_SETREDRAW, FALSE, 0);
			CallWindowProc((WNDPROC)GetClassLong(hwnd,GCL_WNDPROC), hwnd, msg, wParam, lParam);
			SendMessage(hwnd, WM_SETREDRAW, TRUE, 0);
			HeaderEx_Title(hwnd);
		return 0;
	}
//         
// "   ,    " :)
//        , 
//         
	return CallWindowProc((WNDPROC)GetClassLong(hwnd,GCL_WNDPROC), hwnd, msg, wParam, lParam);
}


/*
	 -  DrawFrameControl,   
	,    256 
	,     -?
	      95 (  ,  
	  - )
 */
BOOL DrawFrameControlEx(HDC hdc, LPRECT lprc, UINT uType, UINT uState)
{
	BOOL ret = FALSE;
	if(uType==DFC_BUTTON && GetDeviceCaps(hdc,BITSPIXEL)>=16)
	{
		int offset = 32;
		DWORD cl[2] = { OffsetColor(GetSysColor(COLOR_BTNFACE),offset/2,TRUE), OffsetColor(GetSysColor(COLOR_BTNFACE),offset/2,FALSE) };
		if((uState&DFCS_PUSHED) == DFCS_PUSHED)
		{
			DWORD cll = cl[0];
			cl[0] = cl[1];
			cl[1] = cll;
		}
		int r1 = GetRValue(cl[0]);
		int g1 = GetGValue(cl[0]);
		int b1 = GetBValue(cl[0]);
		int r2 = GetRValue(cl[1]);
		int g2 = GetGValue(cl[1]);
		int b2 = GetBValue(cl[1]);
		HPEN pen = CreatePen(PS_SOLID, 1, cl[0]);
		HPEN opn = SelectPen(hdc, pen);
		for(int y=0;y<=lprc->bottom-lprc->top;y++)
		{
			DWORD cll = RGB(
				r1+(r2-r1)*y/(lprc->bottom-lprc->top),
				g1+(g2-g1)*y/(lprc->bottom-lprc->top),
				b1+(b2-b1)*y/(lprc->bottom-lprc->top));
		//     , ..  
		//  GetNearestColor    
		//   ,   
		//  95.
		//    , ..    ,  
		//     
			HPEN tmp = CreatePen(PS_SOLID, 1, cll);
			SelectPen(hdc, tmp);
			DeletePen(pen);
			pen = tmp;
			MoveToEx(hdc, lprc->left, lprc->top+y, NULL);
			LineTo(hdc, lprc->right, lprc->top+y);
		}
		SelectPen(hdc, opn);
		DeletePen(pen);
		DrawEdge(hdc, lprc, ((uState&DFCS_PUSHED) == DFCS_PUSHED) ? BDR_SUNKENOUTER:EDGE_RAISED, BF_RECT);
	}
	else
	{
	//   ,  -,   !
	// , ,    .
	//      ,    ,
	//   
		ret = DrawFrameControl(hdc, lprc, uType, uState);
	}

	return ret;
}


/*
	      
	  ,  ,  ,   
	.
	:     DT_VCENTER?
	:  ,     DT_WORDBREAK!
 */
BOOL HeaderExVCenter(HDC dc, char* out, RECT* r)
{
	RECT rr,r1;
	CopyRect(&r1,r);
	CopyRect(&rr,r);
	if(((r1.right-1)>r1.left)&&((r1.bottom-7)>r1.top))
	{
		DrawFrameControlEx(dc,&r1,DFC_BUTTON,DFCS_BUTTONPUSH);
		DrawText(dc,out,-1,&r1,DT_WORDBREAK|DT_CENTER|DT_CALCRECT);
		int dist = ((rr.bottom-rr.top)-(r1.bottom-r1.top))/2;
		r1.top+=dist; r1.bottom+=dist; r1.right = rr.right;
		if(dist<0) CopyRect(&r1,&rr);
		DrawText(dc,out,-1,&r1,DT_WORDBREAK|DT_CENTER);
	}
	return TRUE;
}

/*
	     .
	    , 
		RECT **r, char** out
	 ,      ,   
	.        :)
	  -       .
	       ...
 */
void HeaderEx_SetTit(HDC dc, RECT **r, char** out, LPHEADEREXSHOWDATA* l, int pos, int maxstr)
{
	RECT r1,r2;
	char tmp[1000];
	while(*l)
	{
		SetRect(&r1,(*r)->right,(*r)->top,(*r)->right+(*l)->width,(*r)->bottom);
		char *a=(*out);
		for(int i=0;i<=pos;i++)
		{
			a=strchr(a+1,'\n');
			if(!a) { a=(*out)+lstrlen(*out); break; }
		}
		int alen=a-(*out);
		if(*a=='\n' && !strncmp((*out),(*l)->szName,alen))
		{
			int rl=(*r)->left;
			char* b=a=(*out);
			for(int i=0;i<pos;i++)
			{
				a=strchr(a+1,'\n');
				if(!a) { a=(*out)+lstrlen(*out); break; }
			}
			int aa = strchr(a+1,'\n')-a;
			while(!strncmp(b,(*out),alen)) HeaderEx_SetTit(dc, r, out, l, pos+1, maxstr);
			SetRect(&r2,rl,(*r)->top+((*r)->bottom-(*r)->top)*pos/maxstr,(*r)->left,(*r)->top+((*r)->bottom-(*r)->top)*(pos+1)/maxstr);
			lstrcpyn(tmp,a+(*a=='\n' ? 1 : 0),aa+(*a=='\n' ? 0 : 1));
			HeaderExVCenter(dc,tmp,&r2);
			if(pos) return;
			continue;
		}
		a=(*out);
		for(i=0;i<pos;i++)
		{
			a=strchr(a+1,'\n');
			if(!a) { a=(*out)+lstrlen(*out); break; }
			a++;
		}
		SetRect(&r2,(*r)->left,(*r)->top+((*r)->bottom-(*r)->top)*pos/maxstr,(*r)->right,(*r)->bottom);
		HeaderExVCenter(dc,a,&r2);
		CopyRect(*r,&r1);
		if(strncmp((*out),(*l)->szName,a-(*out))) break;
		if(*l) { (*out)=(*l)->szName; (*l)=(*l)->next; }
	}
	if(*l) { (*out)=(*l)->szName; (*l)=(*l)->next; }
	SetRect(&r1,(*r)->right,(*r)->top,2000,(*r)->bottom);
	HeaderExVCenter(dc,"",&r1);
}


/*
	  -    -
	      :(
 */
void HeaderEx_Title(HWND hwnd)
{
	int titleheight = 0;
	RECT r, rw, rc, *r1=&r; char *out="";
	GetWindowRect(hwnd,&r);
	GetWindowRect(hwnd,&rw);
	GetClientRect(hwnd,&rc);
	titleheight = rw.bottom-rw.top;
	HDC dcc = GetDC(hwnd);
	HDC dc = CreateCompatibleDC(dcc);
	HBITMAP bmp = CreateCompatibleBitmap(dcc,r.right-r.left,titleheight);
	HBITMAP oldbmp = SelectBitmap(dc, bmp);
//	HDC dc = GetDC(hwnd);
	SetBkMode(dc,TRANSPARENT);
	HFONT oldfont = SelectFont(dc,GetWindowFont(GetParent(hwnd)));
	int maxstr=0;
	int cnt = Header_GetItemCount(hwnd);
	if(cnt)
	{
		int* ar = new int[cnt];
		Header_GetOrderArray(hwnd, cnt, ar);
		LPHEADEREXSHOWDATA ldata = new HEADEREXSHOWDATA[cnt+1];
		for(int i=0;i<cnt;i++)
		{
			memset(&ldata[i],0,sizeof(ldata[i]));
			HDITEM hdi;
			hdi.mask = HDI_WIDTH|HDI_TEXT;
			hdi.cxy = 0;
			hdi.pszText = ldata[i].szName;
			hdi.cchTextMax = sizeof(ldata[i].szName);
			Header_GetItem(hwnd, ar[i], &hdi);
			ldata[i].width = hdi.cxy;
			ldata[i].next = &ldata[i+1];
		}
		memset(&ldata[cnt],0,sizeof(ldata[cnt]));
		lstrcpy(ldata[cnt].szName,"          ");
		for(LPHEADEREXSHOWDATA l = ldata;l!=NULL;l=l->next)
		{
			int tmp=0; char *a=l->szName;
			while(a) { tmp++; a=strchr(a+1,'\n'); }
			if(maxstr<tmp) maxstr=tmp;
		}

		SetRect(&r,0,0,0,titleheight);
		l = ldata;
		HeaderEx_SetTit(dc, &r1, &out, &l, 0, maxstr);

		delete [] ldata;
		delete [] ar;
	}
	else
	{
		SetRect(&r,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top);
		DrawFrameControlEx(dc,&r,DFC_BUTTON,DFCS_BUTTONPUSH);
	}
	SelectObject(dc,oldfont);
//	ReleaseDC(hwnd, dc);
	SetRect(&r,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top);
	BitBlt(dcc,r.left,r.top,r.right,r.bottom, dc,0,0,SRCCOPY);
	SelectBitmap(dc, oldbmp);
	DeleteBitmap(bmp);
	DeleteDC(dc);
	ReleaseDC(hwnd, dcc);
}
